var PushNot = {
    pushConfig: null,
    pushCategories: null,
    init: function() {
        
        if (typeof localStorage.getItem("push-cat") !== 'undefined' && localStorage.getItem("push-cat") != null) { 
            PushNot.pushCategories = localStorage.getItem("push-cat");
        } else {
            PushNot.setCategories([VATICAN.resources.lang+"-novita",VATICAN.resources.lang+"-bollettino"]);
        }

        PushNot.pushConfig = {
            pushServerURL: "http://push00.glauco.it/ag-push/",
            alias: device.uuid,
            categories : PushNot.pushCategories,
            ios: {
                variantID: "322cea47-9fd7-46e1-b728-aeb1f86f23e3",
                variantSecret: "86995ce8-53e4-491b-90f5-4f1805988545"
            }
        };
        push.register(PushNot.onNotification, PushNot.successHandler, PushNot.errorHandler, PushNot.pushConfig);

    },
    setCategories: function(arCat) {
        localStorage.setItem("push-cat",arCat);
        PushNot.pushCategories = arCat;
    },
    addCategory: function() {

    },
    removeCategory: function() {

    },
    onNotification: function(e) {
        console.log(e);
    },
    onNotificationAPN: function(e) {
        if (e.alert) {

            navigator.notification.confirm(e.alert,function(buttonConf) {
                if (buttonConf==2) {
                    $.extend(opts_page.article,{
                        d_url: e.url,
                        d_title: e.alert
                    });
                    $.extend(opts_page.article.d_json,{
                        url: (e.url).replace(".html",".properties.js"),
                        callback: 'jsonProp'
                    });
                    Navigation.goTo("page/article.html","article");
                }
            },'Novità','Cancel,Vedi');

            //console.log(e.alert);
            //$("#app-status-ul").append('<li>push-notification: ' + e.alert + '</li>');
            //navigator.notification.alert(e.alert);
        }
        /*if (e.sound) {
            var snd = new Media(e.sound);
            snd.play();
        }*/

        if (e.badge) {
            pushNotification.setApplicationIconBadgeNumber(PushNot.successHandler, e.badge);
        }
    },
    onNotificationGCM: function(e) {
        $("#app-status-ul").append('<li>EVENT -> RECEIVED:' + e.event + '</li>');

        switch(e.event) {
            case 'registered':
                if (e.regid.length > 0) {
                    $("#app-status-ul").append('<li>REGISTERED -> REGID:' + e.regid + "</li>");
                    // Your GCM push server needs to know the regID before it can push to this device
                    // here is where you might want to send it the regID for later use.
                    console.log("regID = " + e.regid);
                }
            break;

            case 'message':
                // if this flag is set, this notification happened while we were in the foreground.
                // you might want to play a sound to get the user's attention, throw up a dialog, etc.
                if (e.foreground) {
                    $("#app-status-ul").append('<li>--INLINE NOTIFICATION--' + '</li>');
                    // if the notification contains a soundname, play it.
                    var my_media = new Media("/android_asset/www/"+e.soundname);
                    my_media.play();
                } else {
                	// otherwise we were launched because the user touched a notification in the notification tray.
                    if (e.coldstart) {
                        $("#app-status-ul").append('<li>--COLDSTART NOTIFICATION--' + '</li>');
                    } else {
                        $("#app-status-ul").append('<li>--BACKGROUND NOTIFICATION--' + '</li>');
                    }
                }

                $("#app-status-ul").append('<li>MESSAGE -> MSG: ' + e.payload.message + '</li>');
                //android only
                $("#app-status-ul").append('<li>MESSAGE -> MSGCNT: ' + e.payload.msgcnt + '</li>');
                //amazon-fireos only
                $("#app-status-ul").append('<li>MESSAGE -> TIMESTAMP: ' + e.payload.timeStamp + '</li>');
            break;

            case 'error':
                $("#app-status-ul").append('<li>ERROR -> MSG:' + e.msg + '</li>');
            break;

            default:
                $("#app-status-ul").append('<li>EVENT -> Unknown, an event was received and we do not know what it is</li>');
            break;
        }
    },
    tokenHandler: function(result) {
        console.log("RESULT: "+result);
    },
    successHandler: function(result) {
        console.log("RESULT: "+result);
    },
    errorHandler: function(error) {
        console.log("ERROR: "+error);
    }
}